function varargout = fir_parks_mcclellan_details(varargin)
% FIR_PARKS_MCCLELLAN_DETAILS M-file for fir_parks_mcclellan_details.fig
%      FIR_PARKS_MCCLELLAN_DETAILS, by itself, creates a new FIR_PARKS_MCCLELLAN_DETAILS or raises the existing
%      singleton*.
%
%      H = FIR_PARKS_MCCLELLAN_DETAILS returns the handle to a new FIR_PARKS_MCCLELLAN_DETAILS or the handle to
%      the existing singleton*.
%
%      FIR_PARKS_MCCLELLAN_DETAILS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FIR_parks_MCCLELLAN_DETAILS.M with the given input arguments.
%
%      FIR_PARKS_MCCLELLAN_DETAILS('Property','Value',...) creates a new FIR_PARKS_MCCLELLAN_DETAILS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fir_parks_mcclellan_details_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fir_parks_mcclellan_details_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help fir_parks_mcclellan_details

% Last Modified by GUIDE v2.5 14-Feb-2010 12:47:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fir_parks_mcclellan_details_OpeningFcn, ...
                   'gui_OutputFcn',  @fir_parks_mcclellan_details_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before fir_parks_mcclellan_details is made visible.
function fir_parks_mcclellan_details_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fir_parks_mcclellan_details (see VARARGIN)

% Choose default command line output for fir_parks_mcclellan_details
handles.output = hObject;

%handle of the main window
handles.mainHandles = varargin{1};

%current line number
handles.lineNr = 1;

%initialize filter settings
set(handles.edit_stopLow,'String',get(handles.mainHandles.filter_gui.editStopLow,'String'));
set(handles.edit_stopHigh,'String',get(handles.mainHandles.filter_gui.editStopHigh,'String'));
set(handles.edit_passMin,'String',get(handles.mainHandles.filter_gui.editPassMin,'String'));
set(handles.edit_passMax,'String',get(handles.mainHandles.filter_gui.editPassMax,'String'));
set(handles.edit_attLow,'String',get(handles.mainHandles.filter_gui.editAttLow,'String'));
set(handles.edit_attHigh,'String',get(handles.mainHandles.filter_gui.editAttHigh,'String'));
set(handles.edit_passRipple,'String',get(handles.mainHandles.filter_gui.editRipple,'String'));
set(handles.edit_density,'String',get(handles.mainHandles.filter_gui.editDensity,'String'));



%apply filter
handles.selected = 7;
handles.filteredImage = cell(7);
[handles.filteredImage{handles.selected},handles.filterFct] = fir_parks_mcclellan_procFilter(handles.mainHandles.images{handles.selected},fir_parks_mcclellan_formatArgs(handles.mainHandles.filter_gui),handles.mainHandles);

%raw rf image
pos = get(handles.axes_raw,'Position');
figPos = get(gcf,'Position');
ratio = handles.mainHandles.rfRatio;
width = min(pos(3)*figPos(3),pos(4)*figPos(4)*ratio)/figPos(3);
height = min(pos(4)*figPos(4),pos(3)*figPos(3)/ratio)/figPos(4);
set(handles.axes_raw,'Position',[pos(1:2) width height]);
axes(handles.axes_raw);
colormap(gray);
imagesc(sqrt(abs(hilbert(handles.mainHandles.images{handles.selected}))),'Parent',handles.axes_raw);
xlabel('Line Number');

%number of points for fft; fft is faster, if the number of points is a
%power of two
nfft = 2^nextpow2(handles.mainHandles.rfNumberOfSamples);
%calculate frequency spectrums
%stores all frequency spectrums
handles.fftFct = cell(7,size(handles.mainHandles.images{handles.selected},2));
%stores the average frequency spectrum
handles.fftFctGes = cell(7);
tmp = [];
for x = 1:size(handles.mainHandles.images{handles.selected},2)
    line = handles.mainHandles.images{handles.selected}(:,x,1);
    y = fft(line,nfft)/handles.mainHandles.rfNumberOfSamples;
    handles.fftFct(handles.selected,x)= {2*abs(y(1:nfft/2+1))};
    tmp = [tmp;transpose(handles.fftFct{handles.selected,x}.^4)];
end

handles.fftFctGes(handles.selected) = {sqrt(sqrt(sum(tmp)/size(tmp,1)))};
updateAxes(handles);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes fir_parks_mcclellan_details wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = fir_parks_mcclellan_details_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit_stopLow_Callback(hObject, eventdata, handles)
% hObject    handle to edit_stopLow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_stopLow as text
%        str2double(get(hObject,'String')) returns contents of edit_stopLow as a double


% --- Executes during object creation, after setting all properties.
function edit_stopLow_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_stopLow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_stopHigh_Callback(hObject, eventdata, handles)
% hObject    handle to edit_stopHigh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_stopHigh as text
%        str2double(get(hObject,'String')) returns contents of edit_stopHigh as a double


% --- Executes during object creation, after setting all properties.
function edit_stopHigh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_stopHigh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_passMin_Callback(hObject, eventdata, handles)
% hObject    handle to edit_passMin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_passMin as text
%        str2double(get(hObject,'String')) returns contents of edit_passMin as a double


% --- Executes during object creation, after setting all properties.
function edit_passMin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_passMin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_passMax_Callback(hObject, eventdata, handles)
% hObject    handle to edit_passMax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_passMax as text
%        str2double(get(hObject,'String')) returns contents of edit_passMax as a double


% --- Executes during object creation, after setting all properties.
function edit_passMax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_passMax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_attLow_Callback(hObject, eventdata, handles)
% hObject    handle to edit_attLow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_attLow as text
%        str2double(get(hObject,'String')) returns contents of edit_attLow as a double


% --- Executes during object creation, after setting all properties.
function edit_attLow_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_attLow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_attHigh_Callback(hObject, eventdata, handles)
% hObject    handle to edit_attHigh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_attHigh as text
%        str2double(get(hObject,'String')) returns contents of edit_attHigh as a double


% --- Executes during object creation, after setting all properties.
function edit_attHigh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_attHigh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_passRipple_Callback(hObject, eventdata, handles)
% hObject    handle to edit_passRipple (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_passRipple as text
%        str2double(get(hObject,'String')) returns contents of edit_passRipple as a double


% --- Executes during object creation, after setting all properties.
function edit_passRipple_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_passRipple (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_density_Callback(hObject, eventdata, handles)
% hObject    handle to edit_density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_density as text
%        str2double(get(hObject,'String')) returns contents of edit_density as a double


% --- Executes during object creation, after setting all properties.
function edit_density_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_density (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_rfline.
function button_rfline_Callback(hObject, eventdata, handles)
% hObject    handle to button_rfline (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[x y]  = ginput(1);
x = round(x);
if( x>0 && (x <= handles.mainHandles.rfNumberOfScanlines))
    handles.lineNr = x;
    updateAxes(handles);
end
guidata(gcf,handles);


% --- Executes on button press in button_update.
function button_update_Callback(hObject, eventdata, handles)
% hObject    handle to button_update (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.mainHandles.filter_gui.editStopLow,'String',get(handles.edit_stopLow,'String'));
set(handles.mainHandles.filter_gui.editStopHigh,'String',get(handles.edit_stopHigh,'String'));
set(handles.mainHandles.filter_gui.editPassMin,'String',get(handles.edit_passMin,'String'));
set(handles.mainHandles.filter_gui.editPassMax,'String',get(handles.edit_passMax,'String'));
set(handles.mainHandles.filter_gui.editAttLow,'String',get(handles.edit_attLow,'String'));
set(handles.mainHandles.filter_gui.editAttHigh,'String',get(handles.edit_attHigh,'String'));
set(handles.mainHandles.filter_gui.editRipple,'String',get(handles.edit_passRipple,'String'));
set(handles.mainHandles.filter_gui.editDensity,'String',get(handles.edit_density,'String'));

%reapply filter
handles.filteredImage = cell(7);
[handles.filteredImage{handles.selected},handles.filterFct] = fir_parks_mcclellan_procFilter(handles.mainHandles.images{handles.selected},fir_parks_mcclellan_formatArgs(handles.mainHandles.filter_gui),handles.mainHandles);
updateAxes(handles);
guidata(gcf,handles);


%update images
function updateAxes(handles)

nfft = 2^nextpow2(handles.mainHandles.rfNumberOfSamples);

%raw rf line
line = handles.mainHandles.images{handles.selected}(:,handles.lineNr);

%unfiltered rf line
axes(handles.axes_lineOld);
plot(line, 'b'); 
set(gca,'FontUnits','normalized');
axis([0 length(line) min(line) max(line)]); 
rftitle = sprintf('RF Line: %d (before filtering)', handles.lineNr);
xlabel('Sample Number')
ylabel('Amplitude')
title(rftitle);  

%filtered rf line
line = handles.filteredImage{handles.selected}(:,handles.lineNr);
axes(handles.axes_lineNew);
plot(line, 'b'); 
set(gca,'FontUnits','normalized');
axis([0 length(line) min(line) max(line)]); 
rftitle = sprintf('RF Line: %d (after filtering)', handles.lineNr);
xlabel('Sample Number')
ylabel('Amplitude')
title(rftitle); 

%average spectrum
axes(handles.axes_freqSum);
f = handles.mainHandles.rfSamplingFreq/2*linspace(0,1,nfft/2+1);
h =abs(freqz(handles.filterFct,1,f,handles.mainHandles.rfSamplingFreq));
h = h*max(handles.fftFctGes{handles.selected})/max(h);
plot(f,handles.fftFctGes{handles.selected},f,h); 
set(gca,'FontUnits','normalized');
xlabel('Frequency (Hz)')
ylabel('sqrt4(\Sigma(|Y(f)|^{ 4})')
title('Single-Sided Amplitude Spectrum (average of all RF lines)');

 
%spectrum of a single line
axes(handles.axes_freqSingle);
h = abs(freqz(handles.filterFct,1,f,handles.mainHandles.rfSamplingFreq));
h = h*max(handles.fftFct{handles.selected,handles.lineNr})/max(h);
plot(f,handles.fftFct{handles.selected,handles.lineNr},f,h); 
set(gca,'FontUnits','normalized');
rftitle= sprintf('Single-Sided Amplitude Spectrum of RF line %d',handles.lineNr);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
title(rftitle);


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isfield(handles,'mainHandles')
updateAxes(handles);
end
