function [ processedImage ] = mucro_procFilter( rfImage,argString,handles )
%TEMPLATE_PROCFILTER Summary of this function goes here
%   Detailed explanation goes here
    
    [mode,rest] = strtok(argString,',');
    mode = str2double(mode);
    level = strtok(rest,',');
    level = str2double(level);

    processedImage = rfImage;
    
    if libisloaded('MucroWrap') == false
        loadlibrary('MucroWrap','MucroWrap.h','mfilename','MucroWrap_mfile');
    end
    if calllib('MucroWrap','isAvailable') == 0
        disp 'ERROR: Mucro Libarary is not available'; 
    else
        if calllib('MucroWrap','isInitialized') == 0
            if calllib('MucroWrap','init',which('cv.par')) == 0
                disp 'ERROR: Mucro Libarary could not be initialized';
            end
        end
        processedImage = abs(rfImage);
        [res, rfImage, processedImage] = calllib('MucroWrap','apply', rfImage, processedImage, size(rfImage,2), size(rfImage,1),level, mode);
        if res == 0
            disp 'ERROR: Mucro application failed'; 
        end
    end
    if libisloaded('MucroWrap') == true
        unloadlibrary('MucroWrap');
    end
    
end

